Imports System.Drawing

'    .
Public Class ColumnPrintItem

    '    .
    Public Enum DelimeterTypeEnum
        None = 1
        VerticalLine
        Character
    End Enum

    '           
    Public Enum MeasureColumnWidthEnum
        ByPoints = 1
        ByCharacters
        BySampleText
    End Enum

    '     .
    Public Structure VerticalLineStruct
        Dim Width As Single   '    
        Dim Color As Color '    
    End Structure

    'T   -.
    Public Structure DelimiterCharacterStruct
        Dim Character$  ' 
        Dim Color As Color  '.
    End Structure

    Public ColumnName$                  '   -  objDataView.
    Public HeaderText$                  ' 
    Public HeaderFormat As FormatPrint  ' 
    Public DetailFormat As FormatPrint  ' -
    Public StartX#                       'H      x-.
    Public Width!                       '   points
    Public NbrOfCharacters%              '    .     MeasureColumnWidth=ByCharacters
    Public SampleText$                   ' string   .     MeasureColumnWidth=BySampleText
    Public DelimiterVerticalLine As VerticalLineStruct  '     
    Public DelimiterCharacter As DelimiterCharacterStruct '  o  .
    Public UseDelimiter As DelimeterTypeEnum       '      
    Public IsOverRightMargin As Boolean '       .           StartX
    Public MeasureColumnWidth As MeasureColumnWidthEnum '           

    '-------------------------------------------------------------------------------------
    ' . '  .
    Public Sub New()
        Dim fnt As Font

        fnt = New Font("Arial", 10, FontStyle.Bold, PrintUnitCurrent)
        HeaderFormat = New FormatPrint(fnt, Color.Black, clsPrinting.AlignmentEnum.Left)
        fnt.Dispose()

        fnt = New Font("Arial", 10, FontStyle.Regular, PrintUnitCurrent)
        DetailFormat = New FormatPrint(fnt, Color.Black, clsPrinting.AlignmentEnum.Left)
        fnt.Dispose()

        ColumnName = "" : HeaderText = "" : StartX = 0 : Width = 0 : UseDelimiter = DelimeterTypeEnum.None : IsOverRightMargin = False
        With DelimiterVerticalLine
            .Width = 1
            .Color = Color.Black
        End With
        With DelimiterCharacter
            .Character = "|"
            .Color = Color.Black
        End With
        MeasureColumnWidth = MeasureColumnWidthEnum.ByPoints   ' points       
        NbrOfCharacters = 0 : SampleText = ""

    End Sub
    '-------------------------------------------------------------------------------------
    '     . 
    Public Sub GetItem(ByVal ColItemSource As ColumnPrintItem)

        With ColItemSource
            Me.ColumnName = .ColumnName
            Me.HeaderText = .HeaderText
            Me.HeaderFormat = New FormatPrint(.HeaderFormat)
            Me.DetailFormat = New FormatPrint(.DetailFormat)
            Me.StartX = .StartX
            Me.Width = .Width
            Me.UseDelimiter = .UseDelimiter
            Me.DelimiterCharacter = .DelimiterCharacter
            Me.DelimiterVerticalLine = .DelimiterVerticalLine
            Me.MeasureColumnWidth = .MeasureColumnWidth
            Me.NbrOfCharacters = .NbrOfCharacters
            Me.SampleText = .SampleText
        End With

    End Sub
    '-------------------------------------------------------------------------------------
    '   
    Public Overrides Function ToString$()

        Return ColumnName

    End Function
    '-------------------------------------------------------------------------------------
End Class
