' Library      .
' :   ,  2005, VB.NET 2002
' : Freeware.      Windows  . 
' : mouratx@yahoo.com  ,   http://users.att.sch.gr/mouratx
'      .          .

'Version 1.3

Imports System.ComponentModel
Imports System.Data.OleDb
Imports System.Drawing
Imports System.Drawing.Drawing2D
Imports System.Drawing.Printing
Imports System.IO
Imports System.Windows.Forms

<AttributeUsage(AttributeTargets.All)> _
Public Class clsPrinting

    '   .
    Public Enum AlignmentEnum
        Left = 1
        Center
        Right
    End Enum

    '    
    Public Enum PageOrientationEnum
        Portrait = 1
        Landscape = 2
    End Enum

    '     .
    Public Structure TitleStruct
        Dim Title$
        Dim TitleFormat As FormatPrint
    End Structure

    '       .
    Public Structure PrintDateStruct
        Dim Enabled As Boolean          ' ;
        Dim DateLabel$                  '
        Dim DateString$                  '   
        Dim DateFormat As FormatPrint    ' 
    End Structure

    '        .
    Public Structure PrintPageNumberStruct
        Dim Enabled As Boolean            ' ;
        Dim DisplayTotalPages As Boolean  '     ;
        Dim PageLabel$                    '  
        Dim PageNumber%                   '    
        Dim PageNumberFormat As FormatPrint ' 
    End Structure

    '    A4
    Public Structure PageMarginsStruct
        Dim Portrait As Margins
        Dim Landscape As Margins
    End Structure

    '     
    Public Structure AutoAAStruct
        Dim Enabled As Boolean             ';
        Dim StartFrom%                     ' .
        Dim AA%                            '  .
        Dim Details As ColumnPrintItem      ' .
    End Structure

    '     
    Public Structure PensPrintingStruct
        Dim PenForDetailLine As Pen      ' Pen     Detail .
        Dim PenForHeadFootLine As Pen    ' Pen    Header/Footer .
        Dim PenForDetailLineWidth!       '.
        Dim PenForDetailLineHeight!       '   .   
        Dim PenForHeadFootWidth!
        Dim PenForHeadFootLineHeight!
    End Structure

    '----------  
    Public Columns As ColumnsPrinting  '  .
    Public PrintDoc As PrintDocument   '  .

    '---------    .
    Dim _NbrOfDataRows%               'To     objDataView.  
    Dim _DataRowNbr%                  '     (rowindex).   
    Dim _ErrorMsg%                    '       OnErrorPrinting.
    Dim _HeaderHeight#                '      
    Dim _DetailHeight#                '    Detail 
    Dim _FooterHeight#                '      
    Dim _StringFormat As StringFormat '     MeasureString   PrintFieldAlign 
    Dim _yDelim!                      '    y-    .
    Dim _MaxX#                        '  x-        .     PrintLineOnFieldsOnly=True.
    Dim _TotalPages%                  'O   .           .

    '---------       .
    Dim _objDataView As DataView                  ' DataSource   .
    Dim _Title As TitleStruct                     '   
    Dim _HeaderFormat As FormatPrint              ' default FormatPrint     
    Dim _DetailFormat As FormatPrint              ' default FormatPrint    
    Dim _PageOrientation As PageOrientationEnum   ' .
    Dim _PageMargins As PageMarginsStruct         '    .
    Dim _PageMarginsDefault As PageMarginsStruct  'T    control (,   4).
    Dim _AutoAA As AutoAAStruct                   '  .
    Dim _PrintDetailLines As Boolean              '       .
    Dim _PrintFooterLine As Boolean               '     Footer; 
    Dim _PrintDate As PrintDateStruct             '      
    Dim _PrintPageNumber As PrintPageNumberStruct '    
    Dim _PrintVerticalLineOnLeftMargin As Boolean  '      .
    Dim _PrintVerticalLineOnRightMargin As Boolean  '      .
    Dim _VerticalLineOnLeftMargin As ColumnPrintItem.VerticalLineStruct '       
    Dim _VerticalLineOnRightMargin As ColumnPrintItem.VerticalLineStruct '       
    Dim _PrintUnit As GraphicsUnit                '   .  
    Dim _PensPrinting As PensPrintingStruct       'H    .
    Dim _SpaceWidth%                              '     Points.
    Dim _PrintLineOnFieldsOnly As Boolean         '             .
    Dim _PrintRemainingVerticalLinesOnMargins As Boolean '                   report;
    Dim _DisplayMessageWhenFieldIsOverMargin As Boolean       'N            ; 

    '--------Public EVENTS-------------------
    Public Event OnErrorPrinting(ByVal ErrorMessage$)

    '------------------------------------------------------------------
    '-------------PROPERTIES------------------------------------------
    <Description("     "), Browsable(False), _
    EditorBrowsable(EditorBrowsableState.Always)> _
    Public Property DataSource() As DataView
        Get
            If _objDataView Is Nothing Then Return Nothing
            Return _objDataView
        End Get
        Set(ByVal Value As DataView)
            Try
                _objDataView = New DataView()
                _objDataView = Value
            Catch ex As Exception
                _ErrorMsg = "      " & vbCrLf & ex.Message
                RaiseEvent OnErrorPrinting(_ErrorMsg)
            End Try
        End Set
    End Property
    '------------------------------------------------------------------
    <Description(" "), Browsable(False), _
    EditorBrowsable(EditorBrowsableState.Always)> _
    Public Property Title() As TitleStruct
        Get
            Return _Title
        End Get
        Set(ByVal Value As TitleStruct)
            _Title = Value
        End Set
    End Property
    '-------------------------------------------------------------------
    <Description("   "), Browsable(False), _
    EditorBrowsable(EditorBrowsableState.Always)> _
    Public Property HeaderFormat() As FormatPrint
        Get
            Return _HeaderFormat
        End Get
        Set(ByVal Value As FormatPrint)
            With Value
                _HeaderFormat = New FormatPrint(.Font, .ForeColor, .Alignment, .ContentFormatType, .ContentFormat, .BooleanTranslateFormat)
            End With
        End Set
    End Property
    '-------------------------------------------------------------------
    <Description("  "), Browsable(False), _
    EditorBrowsable(EditorBrowsableState.Always)> _
    Public Property DetailFormat() As FormatPrint
        Get
            Return _DetailFormat
        End Get
        Set(ByVal Value As FormatPrint)
            With Value
                _DetailFormat = New FormatPrint(.Font, .ForeColor, .Alignment, .ContentFormatType, .ContentFormat, .BooleanTranslateFormat)
            End With
        End Set
    End Property
    '-------------------------------------------------------------------
    <Description(" "), Browsable(False), _
    EditorBrowsable(EditorBrowsableState.Always)> _
    Public Property PageOrientation() As PageOrientationEnum
        Get
            Return _PageOrientation
        End Get
        Set(ByVal Value As PageOrientationEnum)
            _PageOrientation = Value
        End Set
    End Property
    '-------------------------------------------------------------------
    <Description("  "), Browsable(False), _
    EditorBrowsable(EditorBrowsableState.Always)> _
    Public Property PageMarginsCurrent() As PageMarginsStruct
        Get
            Return _PageMargins
        End Get
        Set(ByVal Value As PageMarginsStruct)
            Try
                If (Value.Portrait Is Nothing) And (Value.Landscape Is Nothing) Then Exit Property
                If Not (Value.Portrait Is Nothing) Then
                    _PageMargins.Portrait = New Margins() : _PageMargins.Portrait = Value.Portrait
                End If
                If Not (Value.Landscape Is Nothing) Then
                    _PageMargins.Landscape = New Margins() : _PageMargins.Landscape = Value.Landscape
                End If

            Catch ex As Exception
                _ErrorMsg = "        " & vbCrLf & ex.Message
                RaiseEvent OnErrorPrinting(_ErrorMsg)
            End Try

        End Set
    End Property
    '-------------------------------------------------------------------
    <Description("  "), Browsable(False), _
    EditorBrowsable(EditorBrowsableState.Always)> _
    Public Property PageMarginsDefault() As PageMarginsStruct
        Get
            Return _PageMarginsDefault
        End Get
        Set(ByVal Value As PageMarginsStruct)
            Try
                If (Value.Portrait Is Nothing) And (Value.Landscape Is Nothing) Then Exit Property
                If Not (Value.Portrait Is Nothing) Then
                    _PageMarginsDefault.Portrait = New Margins() : _PageMarginsDefault.Portrait = Value.Portrait
                End If
                If Not (Value.Landscape Is Nothing) Then
                    _PageMarginsDefault.Landscape = New Margins() : _PageMarginsDefault.Landscape = Value.Landscape
                End If

            Catch ex As Exception
                _ErrorMsg = "        " & vbCrLf & ex.Message
                RaiseEvent OnErrorPrinting(_ErrorMsg)
            End Try

        End Set
    End Property
    '-------------------------------------------------------------------
    <Description("   ."), Browsable(False), _
    EditorBrowsable(EditorBrowsableState.Always)> _
    Public Property AutoAA() As AutoAAStruct
        Get
            Return _AutoAA
        End Get
        Set(ByVal Value As AutoAAStruct)
            _AutoAA = Value
        End Set
    End Property
    '-------------------------------------------------------------------
    <Description("       ;"), Browsable(False), _
    EditorBrowsable(EditorBrowsableState.Always)> _
    Public Property PrintDetailLines() As Boolean
        Get
            Return _PrintDetailLines
        End Get
        Set(ByVal Value As Boolean)
            _PrintDetailLines = Value
        End Set
    End Property
    '-------------------------------------------------------------------
    <Description("     Footer;"), Browsable(False), _
    EditorBrowsable(EditorBrowsableState.Always)> _
    Public Property PrintFooterLine() As Boolean
        Get
            Return _PrintFooterLine
        End Get
        Set(ByVal Value As Boolean)
            _PrintFooterLine = Value
        End Set
    End Property
    '-------------------------------------------------------------------
    <Description("      ;"), Browsable(False), _
    EditorBrowsable(EditorBrowsableState.Always)> _
    Public Property PrintDate() As PrintDateStruct
        Get
            Return _PrintDate
        End Get
        Set(ByVal Value As PrintDateStruct)
            _PrintDate = Value
        End Set
    End Property
    '-------------------------------------------------------------------
    <Description("    ;"), Browsable(False), _
    EditorBrowsable(EditorBrowsableState.Always)> _
    Public Property PrintPageNumber() As PrintPageNumberStruct
        Get
            Return _PrintPageNumber
        End Get
        Set(ByVal Value As PrintPageNumberStruct)
            _PrintPageNumber = Value
        End Set
    End Property
    '-------------------------------------------------------------------
    <Description("H   "), Browsable(False), _
    EditorBrowsable(EditorBrowsableState.Always)> _
    Public Property PrintUnit() As GraphicsUnit
        Get
            Return _PrintUnit
        End Get
        Set(ByVal Value As GraphicsUnit)
            _PrintUnit = Value
            PrintUnitCurrent = Value '  public      .
        End Set
    End Property
    '-------------------------------------------------------------------
    <Description("    "), Browsable(False), _
    EditorBrowsable(EditorBrowsableState.Always)> _
    Public Property PensPrinting() As PensPrintingStruct
        Get
            Return _PensPrinting
        End Get
        Set(ByVal Value As PensPrintingStruct)
            _PensPrinting = Value
        End Set
    End Property
    '-----------------------------------------------------------------
    <Description("To    "), Browsable(False), _
    EditorBrowsable(EditorBrowsableState.Always)> _
    Public Property SpaceWidth!()
        Get
            Return _SpaceWidth
        End Get
        Set(ByVal Value!)
            If Value > 0 Then _SpaceWidth = Value
        End Set
    End Property
    '-----------------------------------------------------------------
    <Description("      "), Browsable(False), _
    EditorBrowsable(EditorBrowsableState.Always)> _
    Public Property PrintVerticalLineOnLeftMargin() As Boolean
        Get
            Return _PrintVerticalLineOnLeftMargin
        End Get
        Set(ByVal Value As Boolean)
            _PrintVerticalLineOnLeftMargin = Value
        End Set
    End Property
    '-----------------------------------------------------------------
    <Description("      "), Browsable(False), _
    EditorBrowsable(EditorBrowsableState.Always)> _
    Public Property PrintVerticalLineOnRightMargin() As Boolean
        Get
            Return _PrintVerticalLineOnRightMargin
        End Get
        Set(ByVal Value As Boolean)
            _PrintVerticalLineOnRightMargin = Value
        End Set
    End Property
    '-----------------------------------------------------------------
    <Description("       "), Browsable(False), _
    EditorBrowsable(EditorBrowsableState.Always)> _
    Public Property VerticalLineOnLeftMargin() As ColumnPrintItem.VerticalLineStruct
        Get
            Return _VerticalLineOnLeftMargin
        End Get
        Set(ByVal Value As ColumnPrintItem.VerticalLineStruct)
            _VerticalLineOnLeftMargin = Value
        End Set
    End Property
    '-----------------------------------------------------------------
    <Description("       "), Browsable(False), _
    EditorBrowsable(EditorBrowsableState.Always)> _
    Public Property VerticalLineOnRightMargin() As ColumnPrintItem.VerticalLineStruct
        Get
            Return _VerticalLineOnRightMargin
        End Get
        Set(ByVal Value As ColumnPrintItem.VerticalLineStruct)
            _VerticalLineOnRightMargin = Value
        End Set
    End Property
    '-----------------------------------------------------------------
    <Description("             "), Browsable(False), _
    EditorBrowsable(EditorBrowsableState.Always)> _
    Public Property PrintLineOnFieldsOnly() As Boolean
        Get
            Return _PrintLineOnFieldsOnly
        End Get
        Set(ByVal Value As Boolean)
            _PrintLineOnFieldsOnly = Value
        End Set
    End Property
    '-----------------------------------------------------------------
    <Description("                   report;"), Browsable(False), _
    EditorBrowsable(EditorBrowsableState.Always)> _
    Public Property PrintRemainingVerticalLinesOnMargins() As Boolean
        Get
            Return _PrintRemainingVerticalLinesOnMargins
        End Get
        Set(ByVal Value As Boolean)
            _PrintRemainingVerticalLinesOnMargins = Value
        End Set
    End Property
    '-----------------------------------------------------------------
    <Description("N            ; "), Browsable(False), _
EditorBrowsable(EditorBrowsableState.Always)> _
Public Property DisplayMessageWhenFieldIsOverMargin() As Boolean
        Get
            Return _DisplayMessageWhenFieldIsOverMargin
        End Get
        Set(ByVal Value As Boolean)
            _DisplayMessageWhenFieldIsOverMargin = Value
        End Set
    End Property
    '-----------------------------------------------------------------
    '-------------------------------------------------------------------
    '---------------PUBLIC METHODS----------------------------------------
    '-------------------------------------------------------------------
    '
    Public Sub New()

        Try
            PrintUnit = GraphicsUnit.Point
            Dim fnt As Font

            ' 
            '
            fnt = New Font("Arial", 14, FontStyle.Bold, _PrintUnit)
            _Title.Title = "" : _Title.TitleFormat = New FormatPrint(fnt, Color.Black, AlignmentEnum.Center)
            fnt.Dispose()

            ' 
            fnt = New Font("Arial", 10, FontStyle.Bold, _PrintUnit)
            _HeaderFormat = New FormatPrint(fnt, Color.Black, AlignmentEnum.Left)
            fnt.Dispose()

            '  
            fnt = New Font("Arial", 10, FontStyle.Regular, _PrintUnit)
            _DetailFormat = New FormatPrint(fnt, Color.Black, AlignmentEnum.Left)
            fnt.Dispose()

            '  .
            fnt = New Font("Arial", 9, FontStyle.Regular, _PrintUnit)
            With _PrintDate
                .Enabled = True : .DateLabel = "/  : " : .DateString = CStr(Today()) : .DateFormat = New FormatPrint(fnt, Color.Black, AlignmentEnum.Left, FormatPrint.ContentFormatTypeEnum.IsDateFormat, "Short Date")
            End With

            '   .
            With _PrintPageNumber
                .Enabled = True : .DisplayTotalPages = False : .PageLabel = " : " : .PageNumber = 1 : .PageNumberFormat = New FormatPrint(fnt, Color.Black, AlignmentEnum.Right, FormatPrint.ContentFormatTypeEnum.IsNumberFormat, "###")
            End With
            fnt.Dispose()

            '   
            With Me._AutoAA
                .Enabled = True : .StartFrom = 1 : .Details = New ColumnPrintItem() : .Details.ColumnName = "/"
                .Details.HeaderText = "/" : .Details.HeaderFormat = New FormatPrint(_HeaderFormat.Font, Color.Black, AlignmentEnum.Right)
                .Details.Width = 25 : .Details.DetailFormat = New FormatPrint(_DetailFormat.Font, Color.Black, AlignmentEnum.Right, FormatPrint.ContentFormatTypeEnum.IsNumberFormat, "###")
                .Details.MeasureColumnWidth = ColumnPrintItem.MeasureColumnWidthEnum.ByPoints
            End With

            _objDataView = New DataView()
            Columns = New ColumnsPrinting()

            _PageOrientation = PageOrientationEnum.Portrait

            'T  
            With _PageMargins   '       . .. 100=1 , 380=3,80 
                .Portrait = New Margins(30, 270, 20, 380) : .Landscape = New Margins(30, 370, 20, 280)
            End With

            '    
            With _PageMarginsDefault   '       . .. 100=1 , 380=3,80 
                .Portrait = New Margins(30, 270, 20, 380) : .Landscape = New Margins(30, 370, 20, 280)
            End With

            '   ,  ,  ( points)     .
            PrintDetailLines = True : PrintFooterLine = True : _SpaceWidth = 5

            '     .
            _PrintVerticalLineOnLeftMargin = False : _PrintVerticalLineOnRightMargin = False
            _VerticalLineOnLeftMargin.Color = Color.Black : _VerticalLineOnLeftMargin.Width = 2
            _VerticalLineOnRightMargin.Color = Color.Black : _VerticalLineOnRightMargin.Width = 2

            '             .
            _PrintLineOnFieldsOnly = False : _PrintRemainingVerticalLinesOnMargins = True

            '             
            _DisplayMessageWhenFieldIsOverMargin = False

            '     .
            With _PensPrinting
                .PenForDetailLineWidth = 1 : .PenForHeadFootWidth = 2
                .PenForDetailLine = New Pen(Color.Black, .PenForDetailLineWidth) : .PenForHeadFootLine = New Pen(Color.Black, .PenForHeadFootWidth)
                .PenForDetailLine.DashStyle = DashStyle.Solid : .PenForHeadFootLine.DashStyle = DashStyle.Solid
                .PenForDetailLineHeight = 3 : .PenForHeadFootLineHeight = 6
            End With

            '        .
            _StringFormat = New StringFormat(StringFormatFlags.NoWrap)

            PrintDoc = New PrintDocument()
            '     PrintDoc.
            AddHandler PrintDoc.BeginPrint, AddressOf PrintDoc_BeginPrint
            AddHandler PrintDoc.PrintPage, AddressOf PrintDoc_PrintPage
            AddHandler PrintDoc.EndPrint, AddressOf PrintDoc_EndPrint

        Catch ex As Exception
            _ErrorMsg = "       clsPrinting" & vbCrLf & ex.Message
            RaiseEvent OnErrorPrinting(_ErrorMsg)
        End Try

    End Sub
    '-------------------------------------------------------------------
    ' 
    Public Sub PrintPreview()

        Try
            'A      .
            If Columns.Count = 0 Then Exit Sub
            '
            Dim P As New PrintPreviewDialog()
            P.Document = PrintDoc : P.WindowState = FormWindowState.Maximized
            P.ShowDialog()
            P.Dispose()

        Catch ex As Exception
            _ErrorMsg = "    " & vbCrLf & ex.Message
            RaiseEvent OnErrorPrinting(_ErrorMsg)
        End Try

    End Sub
    '-------------------------------------------------------------------
    '
    Public Sub Print()

        Try
            'A      .
            If Columns.Count = 0 Then Exit Sub
            '
            PrintDoc.Print()

        Catch ex As Exception
            _ErrorMsg = "    " & vbCrLf & ex.Message
            RaiseEvent OnErrorPrinting(_ErrorMsg)
        End Try

    End Sub
    '-------------------------------------------------------------------
    '--------------------- PRIVATE METHODS ------------------------------
    '-------------------------------------------------------------------
    '  .
    Private Sub PrintDoc_BeginPrint(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintEventArgs)

        Try
            _NbrOfDataRows = _objDataView.Count  '    .
            _DataRowNbr = 0                      '   indexrow 

            '       .
            _AutoAA.AA = _AutoAA.StartFrom : _PrintPageNumber.PageNumber = 1

            '    AutoAA         1.
            If AutoAA.Enabled Then Me.Columns.Add(0, Me.AutoAA.Details)

            '     .
            With PrintDoc.DefaultPageSettings
                If PageOrientation = PageOrientationEnum.Portrait Then
                    .Landscape = False
                    .Margins = New Margins() : .Margins = _PageMargins.Portrait
                Else
                    .Landscape = True
                    .Margins = New Margins() : .Margins = _PageMargins.Landscape
                End If
            End With

        Catch ex As Exception
            _ErrorMsg = "    " & vbCrLf & ex.Message
            RaiseEvent OnErrorPrinting(_ErrorMsg)
        End Try

    End Sub
    '-------------------------------------------------------------------
    'To rendering   .
    Private Sub PrintDoc_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs)

        e.Graphics.PageUnit = Me.PrintUnit '    .

        Dim y# = e.MarginBounds.Top   '  (   )   .
        Dim LinePrinted As Boolean = False

        '    (StartX)   .        .
        CalculateColsStartX(e)

        '         Detail ..
        If Not CalculateHeaderAndDetailHeight(e) Then
            e.HasMorePages = False
            Exit Sub
        End If

        '      Footer.
        If Not CalculateFooterHeight(e) Then
            e.HasMorePages = False
            Exit Sub
        End If

        '           
        If _PrintPageNumber.DisplayTotalPages Then
            CalculateTotalPages(e)
        End If

        '  (   ...).
        If _PrintPageNumber.PageNumber = 1 Then
            PrintTitle(y, e)
        Else
            _yDelim = y
            PrintDrawLine(PensPrinting.PenForHeadFootLine, y, PensPrinting.PenForHeadFootLineHeight, e)
        End If

        '..   .
        PrintHeader(y, e)

        While Not IsInFooter(y, e)
            _yDelim = y
            LinePrinted = PrintDetailLine(y, e)
            If Not LinePrinted Then
                'T              ( ).
                PrintRemainingVerticalLines(y, e)
                Exit While
            End If

            '       rowindex  1.
            _AutoAA.AA += 1 : _DataRowNbr += 1
        End While

        ' .
        PrintFooter(y, e)

        '       .
        If LinePrinted Then
            e.HasMorePages = True : _PrintPageNumber.PageNumber += 1
        Else
            e.HasMorePages = False
        End If

    End Sub
    '-------------------------------------------------------------------
    '  .
    Private Sub PrintDoc_EndPrint(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintEventArgs)


    End Sub
    '----------------------------------------------------------------------------------------
    '----------    ,     PrintPage--------------------------------------
    '----------------------------------------------------------------------------------------
    '   .
    Private Function PrintTitle(ByRef y#, ByVal e As PrintPageEventArgs) As Boolean

        Try
            With Me.Title
                PrintFieldAlign(.Title, e.MarginBounds.Left, e.MarginBounds.Width, .TitleFormat, False, y#, e)
                '    .
                y = y + .TitleFormat.Font.GetHeight(e.Graphics)
            End With
            _yDelim = y
            ' .
            PrintDrawLine(PensPrinting.PenForHeadFootLine, y, PensPrinting.PenForHeadFootLineHeight, e)
            Return True
        Catch
            Return False
        End Try

    End Function
    '-------------------------------------------------------------------------------------------
    '    .
    Private Function PrintHeader(ByRef y#, ByVal e As PrintPageEventArgs) As Boolean

        Dim i%, nbrcols%
        Dim ColItem As New ColumnPrintItem()

        Try
            '     ,   .
            PrintVerticalLineOnMargins("Left", "Header", y, e)

            nbrcols = Columns.Count

            '     
            For i = 0 To nbrcols - 1

                '  
                ColItem = Columns(i)
                With ColItem
                    If Not .IsOverRightMargin Then
                        ' .
                        PrintFieldAlign(.HeaderText, .StartX, .Width, .HeaderFormat, False, y, e)
                        '   
                        PrintDelimiter(ColItem, "Header", y, e)
                    End If
                End With
            Next

            '     ,   .
            PrintVerticalLineOnMargins("Right", "Header", y, e)

            '    .
            y = y + _HeaderHeight

            ' .
            PrintDrawLine(PensPrinting.PenForHeadFootLine, y, PensPrinting.PenForHeadFootLineHeight, e)
            Return True

        Catch ex As Exception
            Return False
        End Try

    End Function
    '-------------------------------------------------------------------------------------------
    '  Detail .
    Private Function PrintDetailLine(ByRef y#, ByVal e As PrintPageEventArgs) As Boolean

        Dim i%, nbrCols%
        Dim fldValue As Object
        Dim ColItem As New ColumnPrintItem()

        Try
            If _DataRowNbr <= _NbrOfDataRows - 1 Then
                '  .
                Dim r As DataRowView = _objDataView(_DataRowNbr)

                '     ,   .
                PrintVerticalLineOnMargins("Left", "Detail", y, e)

                nbrCols = Columns.Count

                '     
                For i = 0 To nbrCols - 1

                    '  
                    ColItem = Columns(i)
                    With ColItem
                        If Not .IsOverRightMargin Then
                            If .ColumnName = "/" Then
                                fldValue = _AutoAA.AA
                            Else
                                '    .
                                fldValue = r.Item(.ColumnName)
                                '  DBNull value
                                If fldValue Is DBNull.Value Then fldValue = ""
                            End If
                            ' .
                            PrintFieldAlign(fldValue, .StartX, .Width, .DetailFormat, True, y, e)
                            '   
                            PrintDelimiter(ColItem, "Detail", y, e)
                        End If
                    End With
                Next

                '     ,   .
                PrintVerticalLineOnMargins("Right", "Detail", y, e)

                '    .
                y = y + _DetailHeight

                ' .
                If Me.PrintDetailLines Then
                    PrintDrawLine(PensPrinting.PenForDetailLine, y, PensPrinting.PenForDetailLineHeight, e)
                End If

                Return True
            Else
                Return False
            End If

        Catch ex As Exception
            _ErrorMsg = "      " & _DataRowNbr & vbCrLf & ex.Message
            RaiseEvent OnErrorPrinting(_ErrorMsg)
            Return False
        End Try

    End Function
    '-------------------------------------------------------------------------------------------
    ' o Footer.
    Private Function PrintFooter(ByRef y#, ByVal e As PrintPageEventArgs) As Boolean

        Try
            '   . 
            y = e.MarginBounds.Bottom - (PensPrinting.PenForHeadFootLineHeight + _FooterHeight)

            '  footer,   .
            If _PrintFooterLine Then
                PrintDrawLineOnFooter(PensPrinting.PenForHeadFootLine, y, PensPrinting.PenForHeadFootLineHeight, e)
            Else
                y = y + PensPrinting.PenForHeadFootLineHeight
            End If

            '      .
            With PrintDate
                If .Enabled Then
                    Dim DateFormatted$
                    '     /   ...
                    If .DateFormat.ContentFormatType = FormatPrint.ContentFormatTypeEnum.IsDateFormat Then
                        DateFormatted$ = .DateLabel & Format(.DateString, .DateFormat.ContentFormat)
                    Else
                        '...    .
                        DateFormatted$ = .DateLabel & .DateString
                    End If
                    PrintFieldAlign(DateFormatted, e.MarginBounds.Left, e.MarginBounds.Width, .DateFormat, False, y, e)
                End If
            End With

            With PrintPageNumber
                If .Enabled Then
                    Dim PageNumberFormatted$ = .PageLabel & Format(.PageNumber, .PageNumberFormat.ContentFormat) & IIf(.DisplayTotalPages, " / " & Format(_TotalPages, .PageNumberFormat.ContentFormat), "")
                    PrintFieldAlign(PageNumberFormatted, e.MarginBounds.Left, e.MarginBounds.Width, .PageNumberFormat, False, y, e)
                End If
            End With

            y = y + _FooterHeight
            Return True
        Catch
            Return False
        End Try

    End Function

    '-------------------------------------------------------------------------------------------
    '    ,      dblWidth.  !
    '     ,   .  '    
    Private Function PrintFieldAlign(ByVal strFieldValue As Object, ByVal StartX#, ByVal dblWidth#, ByVal whatFormatPrint As FormatPrint, ByVal UseContentFormat As Boolean, ByVal y#, ByVal e As PrintPageEventArgs) As Boolean

        If CStr(strFieldValue) = "" Then Exit Function

        Dim rect As RectangleF        '        .
        Dim x#                        '       .
        Dim BrushPrint As SolidBrush  '   .
        Dim ValueFormatted$           '   ,  

        Try
            BrushPrint = New SolidBrush(whatFormatPrint.ForeColor)

            '  ,         .
            With whatFormatPrint

                If UseContentFormat Then
                    Select Case .ContentFormatType
                        Case Is = FormatPrint.ContentFormatTypeEnum.NoDefined : ValueFormatted = strFieldValue 'no format/ simple text.
                        Case Is = FormatPrint.ContentFormatTypeEnum.IsNumberFormat, FormatPrint.ContentFormatTypeEnum.IsDateFormat : ValueFormatted = Format(strFieldValue, .ContentFormat) ', /
                        Case Is = FormatPrint.ContentFormatTypeEnum.IsBooleanFormat : ValueFormatted = .GetBooleanString(strFieldValue, .BooleanTranslateFormat) 'format  boolean 
                    End Select
                Else
                    ValueFormatted = strFieldValue 'no format/ simple text.
                End If

                '            Font. 
                '  ,         .
                Dim fldWidth As SizeF = e.Graphics.MeasureString(ValueFormatted, .Font, CInt(dblWidth), _StringFormat)

                ', ,           .
                Select Case .Alignment

                    Case Is = AlignmentEnum.Left   'Left
                        x = StartX

                    Case Is = AlignmentEnum.Right  'right
                        x = StartX + dblWidth - fldWidth.Width

                    Case Is = AlignmentEnum.Center  'Center
                        x = StartX + dblWidth / 2 - fldWidth.Width / 2
                End Select

                '         .
                With rect
                    .X = x : .Y = y
                    .Width = fldWidth.Width : .Height = whatFormatPrint.Font.GetHeight(e.Graphics)
                End With

                '  .
                e.Graphics.DrawString(ValueFormatted, .Font, BrushPrint, rect)
            End With

            Return True
        Catch
            Return False
        Finally
            rect = Nothing : BrushPrint.Dispose()
        End Try

    End Function
    '--------------------------------------------------------------------------------------
    'T   header/footer  detail line.
    Private Sub PrintDrawLine(ByVal whatPen As Pen, ByRef y#, ByVal whatPenHeight#, ByVal e As PrintPageEventArgs)

        'e.Graphics.DrawLine(whatPen, e.MarginBounds.Left, CSng(y), e.MarginBounds.Right, CSng(y))
        e.Graphics.DrawLine(whatPen, e.MarginBounds.Left, CSng(y), CSng(_MaxX), CSng(y))
        y = y + whatPenHeight

    End Sub
    '--------------------------------------------------------------------------------------
    'T   footer .
    Private Sub PrintDrawLineOnFooter(ByVal whatPen As Pen, ByRef y#, ByVal whatPenHeight#, ByVal e As PrintPageEventArgs)

        e.Graphics.DrawLine(whatPen, e.MarginBounds.Left, CSng(y), e.MarginBounds.Right, CSng(y))
        y = y + whatPenHeight

    End Sub
    '--------------------------------------------------------------------------------------
    '  ,       .    .
    'O      DetailFormat,    
    Private Sub PrintDelimiter(ByVal colItem As ColumnPrintItem, ByVal whatZone$, ByVal y#, ByVal e As PrintPageEventArgs)

        Try
            '    .
            If colItem.UseDelimiter = ColumnPrintItem.DelimeterTypeEnum.None Then Exit Sub

            ',       .
            Dim BrushChar As SolidBrush  '      .
            Dim PenVerticalLine As Pen   '     VerticalLine.
            Dim rect As RectangleF       '       o .
            Dim x#                        '     

            ', ,         SpaceWidth.
            x = colItem.StartX + colItem.Width + SpaceWidth / 2

            If colItem.UseDelimiter = ColumnPrintItem.DelimeterTypeEnum.VerticalLine Then
                '           ,   
                Dim VLineWidth! = IIf(colItem.DelimiterVerticalLine.Width < SpaceWidth, colItem.DelimiterVerticalLine.Width, SpaceWidth)
                PenVerticalLine = New Pen(colItem.DelimiterVerticalLine.Color, VLineWidth)
                With rect
                    .X = x - VLineWidth / 2 : .Y = _yDelim
                    .Width = VLineWidth
                    .Height = IIf(whatZone = "Detail", _DetailHeight + PensPrinting.PenForDetailLineHeight, _HeaderHeight + PensPrinting.PenForHeadFootLineHeight + _DetailHeight)
                End With
                ' .
                e.Graphics.DrawLine(PenVerticalLine, rect.X, rect.Y, rect.X, rect.Bottom)
                PenVerticalLine.Dispose()
            Else
                BrushChar = New SolidBrush(colItem.DelimiterCharacter.Color)
                '            Font. 
                '  ,        SpaceWidth.
                Dim DelimCharFormat As FormatPrint = IIf(whatZone = "Detail", New FormatPrint(Me.DetailFormat), New FormatPrint(Me.HeaderFormat))
                Dim DelimWidth As SizeF = e.Graphics.MeasureString(colItem.DelimiterCharacter.Character, DelimCharFormat.Font, SpaceWidth)
                '       .
                With rect
                    .X = x - DelimWidth.Width / 2 : .Y = y
                    .Width = DelimWidth.Width
                    .Height = IIf(whatZone = "Detail", _DetailHeight, _HeaderHeight)
                End With
                ' .
                e.Graphics.DrawString(colItem.DelimiterCharacter.Character, DelimCharFormat.Font, BrushChar, rect)
                BrushChar.Dispose() : DelimCharFormat = Nothing
            End If
            rect = Nothing
        Catch
        End Try

    End Sub
    '--------------------------------------------------------------------------------------
    '        .
    Private Sub PrintVerticalLineOnMargins(ByVal whatMargin$, ByVal whatZone$, ByVal y#, ByVal e As PrintPageEventArgs)

        Dim VLineWidth!             'To    
        Dim rect As RectangleF       '        .
        Dim PenVerticalLine As Pen   '     VerticalLine.

        Select Case whatMargin
            Case Is = "Left"
                If _PrintVerticalLineOnLeftMargin Then
                    VLineWidth! = IIf(_VerticalLineOnLeftMargin.Width < SpaceWidth, _VerticalLineOnLeftMargin.Width, SpaceWidth)
                    PenVerticalLine = New Pen(_VerticalLineOnLeftMargin.Color, VLineWidth)
                    With rect
                        .X = e.MarginBounds.Left : .Y = _yDelim 'y
                        .Width = VLineWidth
                        .Height = IIf(whatZone = "Detail", _DetailHeight + PensPrinting.PenForDetailLineHeight, _HeaderHeight + PensPrinting.PenForHeadFootLineHeight + _DetailHeight)
                    End With
                    ' .
                    e.Graphics.DrawLine(PenVerticalLine, rect.X, rect.Y, rect.X, rect.Bottom)
                    PenVerticalLine.Dispose()
                End If
            Case Is = "Right"
                If _PrintVerticalLineOnRightMargin Then
                    VLineWidth! = IIf(_VerticalLineOnRightMargin.Width < SpaceWidth, _VerticalLineOnRightMargin.Width, SpaceWidth)
                    PenVerticalLine = New Pen(_VerticalLineOnRightMargin.Color, VLineWidth)
                    With rect
                        .X = e.MarginBounds.Right : .Y = _yDelim 'y  'e.MarginBounds.Right - VLineWidth
                        .Width = VLineWidth
                        .Height = IIf(whatZone = "Detail", _DetailHeight + PensPrinting.PenForDetailLineHeight, _HeaderHeight + PensPrinting.PenForHeadFootLineHeight + _DetailHeight)
                    End With
                    ' .
                    e.Graphics.DrawLine(PenVerticalLine, rect.X, rect.Y, rect.X, rect.Bottom)
                    PenVerticalLine.Dispose()
                End If
        End Select
    End Sub
    '--------------------------------------------------------------------------------------
    '        ,        ( ).
    Private Function PrintRemainingVerticalLines(ByVal y#, ByVal e As System.Drawing.Printing.PrintPageEventArgs) As Boolean

        '       .
        If ((_PrintVerticalLineOnLeftMargin = False) And (_PrintVerticalLineOnRightMargin = False)) Or (_PrintRemainingVerticalLinesOnMargins = False) Then Exit Function

        Try
            '   
            Dim colitem As New ColumnPrintItem()
            colitem = Columns(Columns.Count - 1)

            While Not IsInFooter(y, e)
                _yDelim = y
                '     ,   .
                PrintVerticalLineOnMargins("Left", "Detail", y, e)
                '     ,   ,  
                '       .
                If _PrintVerticalLineOnRightMargin Then
                    PrintVerticalLineOnMargins("Right", "Detail", y, e)
                Else
                    PrintDelimiter(colitem, "Detail", y, e)
                End If

                '    .
                y = y + _DetailHeight

            End While
            colitem = Nothing
            Return True

        Catch
            Return False
        End Try

    End Function
    '-------------------------------------------------------------------
    '    StartX    x-  . 
    '       
    Private Function CalculateColsStartX(ByVal e As System.Drawing.Printing.PrintPageEventArgs) As Boolean

        Try
            Dim RightMargin# = e.MarginBounds.Right '   .
            Dim ColItemCurrent As New ColumnPrintItem(), ColItemPrevious As New ColumnPrintItem()
            Dim i%
            Dim nbrCols% = Columns.Count
            Dim LastColOnPage% = nbrCols - 1 '    

            For i = 0 To nbrCols - 1
                ColItemCurrent = Columns(i)
                If i = 0 Then
                    '  1 .      .
                    If _PrintVerticalLineOnLeftMargin Then
                        ColItemCurrent.StartX = e.MarginBounds.Left + (SpaceWidth - _VerticalLineOnLeftMargin.Width)
                    Else
                        ColItemCurrent.StartX = e.MarginBounds.Left
                    End If
                    ColItemPrevious = ColItemCurrent
                Else
                    '   
                    ColItemPrevious = Columns(i - 1)
                    '          string     ().
                    Select Case ColItemPrevious.MeasureColumnWidth
                        Case Is = ColumnPrintItem.MeasureColumnWidthEnum.ByCharacters
                            ColItemPrevious.Width = GetColumnWidthFromNbrOfCharacters(ColItemPrevious, e)
                        Case Is = ColumnPrintItem.MeasureColumnWidthEnum.BySampleText
                            ColItemPrevious.Width = GetColumnWidthFromSampleText(ColItemPrevious, e)
                    End Select
                    If ColItemPrevious.MeasureColumnWidth = ColumnPrintItem.MeasureColumnWidthEnum.ByCharacters Then
                        ColItemPrevious.Width = GetColumnWidthFromNbrOfCharacters(ColItemPrevious, e)
                    End If
                    ColItemCurrent.StartX = ColItemPrevious.StartX + ColItemPrevious.Width + SpaceWidth
                End If
                '          .
                If (ColItemPrevious.StartX + ColItemPrevious.Width + SpaceWidth) > RightMargin Then
                    '        .          .
                    If _DisplayMessageWhenFieldIsOverMargin Then
                        MsgBox("    " & ColItemPrevious.ColumnName & "      ." & vbCrLf & "To   .       ", MsgBoxStyle.Information, "")
                    End If
                    ColItemPrevious.Width = RightMargin - ColItemPrevious.StartX
                    '    
                    LastColOnPage = i
                    '   ,   ,   .
                    Dim k%
                    For k = i To nbrCols - 1
                        Columns(k).IsOverRightMargin = True
                    Next
                    Exit For
                End If
                '  ColItemPrevious        ColItemCurrent    .           .
                '      ColItemCurrent    . 
                Select Case ColItemCurrent.MeasureColumnWidth
                    Case Is = ColumnPrintItem.MeasureColumnWidthEnum.ByCharacters
                        ColItemCurrent.Width = GetColumnWidthFromNbrOfCharacters(ColItemCurrent, e)
                    Case Is = ColumnPrintItem.MeasureColumnWidthEnum.BySampleText
                        ColItemCurrent.Width = GetColumnWidthFromSampleText(ColItemCurrent, e)
                End Select
                If (i = nbrCols - 1) And ((ColItemCurrent.StartX + ColItemCurrent.Width + SpaceWidth) > RightMargin) Then
                    If _DisplayMessageWhenFieldIsOverMargin Then
                        MsgBox("    " & ColItemCurrent.ColumnName & "      ." & vbCrLf & "To   .", MsgBoxStyle.Information, "")
                    End If
                    ColItemCurrent.Width = RightMargin - ColItemCurrent.StartX
                End If
            Next

            '   x-,         . 
            If (_PrintLineOnFieldsOnly) Then    'Or (Not _PrintVerticalLineOnRightMargin)
                If nbrCols = 0 Then _MaxX = e.MarginBounds.Left Else _MaxX = Columns(LastColOnPage).StartX + Columns(LastColOnPage).Width + SpaceWidth / 2 '  Delimiter,     Spacewidth.
            Else
                _MaxX = RightMargin
            End If

            Return True

        Catch ex As Exception
            _ErrorMsg = "        " & vbCrLf & ex.Message
            RaiseEvent OnErrorPrinting(_ErrorMsg)
            Return False
        End Try

    End Function
    '--------------------------------------------------------------------------------------
    '          .
    Private Function CalculateHeaderAndDetailHeight(ByVal e As System.Drawing.Printing.PrintPageEventArgs) As Boolean

        Try
            Dim ColItem As ColumnPrintItem
            Dim MaxHeightHeader# = 1
            Dim MaxHeightDetail# = 1
            Dim i%
            Dim nbrCols% = Columns.Count

            For i = 0 To nbrCols - 1
                ColItem = Columns(i)
                ' Header
                If ColItem.HeaderFormat.Font.GetHeight(e.Graphics) > MaxHeightHeader Then
                    MaxHeightHeader = ColItem.HeaderFormat.Font.GetHeight(e.Graphics)
                End If
                ' Detail
                If ColItem.DetailFormat.Font.GetHeight(e.Graphics) > MaxHeightDetail Then
                    MaxHeightDetail = ColItem.DetailFormat.Font.GetHeight(e.Graphics)
                End If
            Next

            _HeaderHeight = MaxHeightHeader : _DetailHeight = MaxHeightDetail
            Return True

        Catch ex As Exception
            _ErrorMsg = "         " & vbCrLf & ex.Message
            RaiseEvent OnErrorPrinting(_ErrorMsg)
            Return False
        End Try

    End Function
    '--------------------------------------------------------------------------------------
    '        fonts  PrintDate  PrintPageNumber.
    Private Function CalculateFooterHeight(ByVal e As System.Drawing.Printing.PrintPageEventArgs) As Boolean

        Try
            Dim DateHeight# = PrintDate.DateFormat.Font.GetHeight(e.Graphics)
            Dim PageNumberHeight# = PrintPageNumber.PageNumberFormat.Font.GetHeight(e.Graphics)

            _FooterHeight = IIf(DateHeight > PageNumberHeight, DateHeight, PageNumberHeight)
            Return True

        Catch ex As Exception
            _ErrorMsg = "      " & vbCrLf & ex.Message
            RaiseEvent OnErrorPrinting(_ErrorMsg)
            Return False
        End Try

    End Function
    '--------------------------------------------------------------------------------------
    '    .      -
    '       ( Title-header-Detail-footer-Lines).
    Private Function CalculateTotalPages(ByVal e As System.Drawing.Printing.PrintPageEventArgs) As Boolean

        Try
            Dim MarginTop# = e.MarginBounds.Top
            Dim Pages% = 1  '   
            Dim y#       '    .        .
            Dim IsEndOfRecords As Boolean = False '     
            Dim IsFirstPage As Boolean = True  '    
            Dim TitleHeight# = _Title.TitleFormat.Font.GetHeight(e.Graphics)  ' 
            Dim r% = 1    '  

            While Not IsEndOfRecords
                y = e.MarginBounds.Top  '   y     .
                '          .
                If IsFirstPage Then
                    y += TitleHeight : IsFirstPage = False
                End If

                '    header    header (  )
                y += _PensPrinting.PenForHeadFootLineHeight + _HeaderHeight + _PensPrinting.PenForHeadFootLineHeight

                '   while      footer.
                While Not IsInFooter(y, e)
                    If r <= _NbrOfDataRows Then
                        '    Detail          
                        y += _DetailHeight + IIf(_PrintDetailLines, _PensPrinting.PenForDetailLineHeight, 0)
                        '      1.
                        r += 1
                    Else
                        IsEndOfRecords = True
                        Exit While
                    End If
                End While

                If Not IsEndOfRecords Then Pages += 1

            End While

            '      .
            _TotalPages = Pages
            Return True

        Catch
            _TotalPages = 0
            Return False
        End Try

    End Function
    '-------------------------------------------------------------------------------------
    '         footer.
    Private Function IsInFooter(ByVal y#, ByVal e As PrintPageEventArgs) As Boolean

        If (y + PensPrinting.PenForHeadFootLineHeight + 2 * _FooterHeight >= e.MarginBounds.Bottom) Or (y + _DetailHeight >= e.MarginBounds.Bottom) Then
            Return True
        Else
            Return False
        End If

    End Function
    '--------------------------------------------------------------------------------------
    '            ().
    Private Function GetColumnWidthFromNbrOfCharacters!(ByVal colItem As ColumnPrintItem, ByVal e As System.Drawing.Printing.PrintPageEventArgs)

        ' .       "9".
        Dim ch$
        If colItem.DetailFormat.ContentFormatType = FormatPrint.ContentFormatTypeEnum.IsNumberFormat Then
            ch = "9"
        Else
            ch = "X"
        End If

        Dim SampleText$ = ""  ' string.
        Dim NbrOfCharacters% = colItem.NbrOfCharacters  '    
        Dim WidthSampleText As SizeF
        Dim i%

        '   string.
        For i = 1 To NbrOfCharacters
            SampleText += ch
        Next

        Try
            WidthSampleText = e.Graphics.MeasureString(SampleText, colItem.DetailFormat.Font)
            Return WidthSampleText.Width
        Catch
            Return 1
        End Try

    End Function
    '-------------------------------------------------------------------------------------
    '        string    .
    Private Function GetColumnWidthFromSampleText!(ByVal colItem As ColumnPrintItem, ByVal e As System.Drawing.Printing.PrintPageEventArgs)

        Dim SampleText$ = colItem.SampleText   ' string.
        Dim WidthSampleText As SizeF
        Dim i%

        Try
            WidthSampleText = e.Graphics.MeasureString(SampleText, colItem.DetailFormat.Font)
            Return WidthSampleText.Width
        Catch
            Return 1
        End Try

    End Function
    '-------------------------------------------------------------------------------------
    Protected Overrides Sub Finalize()
        MyBase.Finalize()

        Try
            Columns = Nothing : PrintDoc.Dispose()
            '     PrintDoc.
            RemoveHandler PrintDoc.BeginPrint, AddressOf PrintDoc_BeginPrint
            RemoveHandler PrintDoc.PrintPage, AddressOf PrintDoc_PrintPage
            RemoveHandler PrintDoc.EndPrint, AddressOf PrintDoc_EndPrint
        Catch
        End Try
    End Sub
    '-------------------------------------------------------------------

End Class
